<%@ page contentType="text/html; charset=utf-8" %>
<%@ page language="java" %>
<%@ page errorPage="/errorPage.jsp" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<html:xhtml />
<%@ page import="com.sas.apps.citation.util.CommonUtils" %>
<%@ page import="com.sas.apps.citation.view.beans.datetime.DateTimeFieldForm" %>
<%@ page import="com.sas.apps.citation.view.beans.filterrank.section.relational.EditFilterFormUiAdapter" %>
<%@ page import="com.sas.apps.citation.view.beans.filterrank.relational.datetime.DateValueForm" %>
<%@ page import="com.sas.apps.citation.view.beans.filterrank.relational.datetime.PeriodType" %>
<%@ page import="com.sas.apps.citation.view.beans.filterrank.relational.datetime.RelativeDateValueAlias" %>
<%@ page import="com.sas.apps.citation.view.beans.filterrank.relational.datetime.RelationalTimeConditionFormInterface" %>
<%@ page import="com.sas.apps.citation.view.beans.filterrank.relational.datetime.RelationalTimeConditionFormProviderInterface" %>
<%@ page import="com.sas.apps.citation.view.contentgeneration.filterrank.relational.RelationalTimeConditionPanelContentGenerator" %>
<%@ page import="com.sas.apps.citation.view.tbeans.html.datetime.DateTimeFieldSelector" %>
<%@ page import="com.sas.apps.citation.view.beans.BeanValidator" %>
<%@ page import="com.sas.apps.citation.view.beans.BeanValidator.BeanValidatorXSSException" %>


<%@ page import="org.apache.struts.util.LabelValueBean" %>

<%
//    SessionScopeManager sessionScopeManager = SessionScopeManager
//        .getSessionScopeManager(pageContext.getRequest());

    String panelId = request.getParameter(RelationalTimeConditionPanelContentGenerator.TIME_CONDITION_PANEL_ID);
	try
	{
		BeanValidator.validateGeneralStringContent(panelId);
	} catch (BeanValidatorXSSException e)
	{
		throw new IllegalArgumentException("SECURITY VIOLATION: potential cross-site scripting detected");
	}

    String timeConditionProviderName = request.getParameter(RelationalTimeConditionPanelContentGenerator.TIME_CONDITION_PROVIDER_KEY);
	try
	{
		BeanValidator.validateGeneralStringContent(timeConditionProviderName);
	} catch (BeanValidatorXSSException e)
	{
		throw new IllegalArgumentException("SECURITY VIOLATION: potential cross-site scripting detected");
	}
	
    RelationalTimeConditionFormProviderInterface timeConditionFormProvider = (RelationalTimeConditionFormProviderInterface)
        session.getAttribute(timeConditionProviderName);
    RelationalTimeConditionFormInterface timeConditionForm = timeConditionFormProvider.getRelationalTimeConditionForm();
    
    //string to serve as root of all ids generated for ctrls within panel
    //To start the provider name doubles as the id.
    
    //TODO pass in as request parm
    String endPointType = request.getParameter(
        RelationalTimeConditionPanelContentGenerator.TIME_RANGE_END_POINT_TYPE_KEY);
    boolean isMinEndPoint = RelationalTimeConditionPanelContentGenerator.TIME_RANGE_END_POINT_TYPE_MIN.
        equals(endPointType);
 
    boolean isRelativeTimeFilteringAllowed;  
     
    String endPointLabelKey;
           
    String dateValueTypeProperty;      
    String relativeDateAliasSelectorProperty;
    String relativeNPeriodMultiplierProperty;
    String relativeNPeriodTypeProperty;
    String explicitValueEditorName;

    String endPointContainerId;
    String dateValueTypeRadioRelativeId;
    String dateValueTypeRadioExplicitId;
    String relativeDateAliasSelectorId;
    String relativeNPeriodsContainerId;
    String relativeNPeriodMultiplierFieldId;
    String relativeNPeriodTypeDropdownId;
    String explicitValueControlsContainerId;
    
//+++TODO    String boundaryPointControlSetKey        = "g_filterRankDialog.FIELDSETKEY_MAX_DATE_CONTROLS";
    
    if (isMinEndPoint)
    {
        isRelativeTimeFilteringAllowed = timeConditionForm.getStartDate().isRelativeTimeFilteringAllowed();
        
        endPointLabelKey = "filter.dateLikeItem.between.min.value.editor.label.txt";
     
        dateValueTypeProperty             = RelationalTimeConditionPanelContentGenerator.MIN_VALUE_OPTION_PROPERTY;
        relativeDateAliasSelectorProperty = RelationalTimeConditionPanelContentGenerator.MIN_RELATIVE_DATE_ALIAS_PROPERTY;
        relativeNPeriodMultiplierProperty = RelationalTimeConditionPanelContentGenerator.MIN_RELATIVE_N_PERIODS_MULTIPLIER_PROPERTY ;
        relativeNPeriodTypeProperty       = RelationalTimeConditionPanelContentGenerator.MIN_RELATIVE_N_PERIOD_TYPE_PROPERTY ;
        explicitValueEditorName           = RelationalTimeConditionPanelContentGenerator.MIN_EXPLICIT_DATE_PROPERTY;
    
        endPointContainerId              = timeConditionProviderName + RelationalTimeConditionPanelContentGenerator.CORE_MIN_VALUE_OPTIONS_CONTAINER_ID;
        dateValueTypeRadioRelativeId     = timeConditionProviderName + RelationalTimeConditionPanelContentGenerator.CORE_MIN_VALUE_OPTION_RELATIVE_ID ;
        dateValueTypeRadioExplicitId     = timeConditionProviderName + RelationalTimeConditionPanelContentGenerator.CORE_MIN_VALUE_OPTION_EXPLICIT_ID ;
        relativeDateAliasSelectorId      = timeConditionProviderName + RelationalTimeConditionPanelContentGenerator.CORE_MIN_RELATIVE_DATE_ALIAS_SELECTOR_ID ;
        relativeNPeriodsContainerId      = timeConditionProviderName + RelationalTimeConditionPanelContentGenerator.CORE_MIN_RELATIVE_N_PERIODS_CONTAINER_ID;
        relativeNPeriodMultiplierFieldId = timeConditionProviderName + RelationalTimeConditionPanelContentGenerator.CORE_MIN_RELATIVE_N_PERIODS_MULTIPLIER_ID;
        relativeNPeriodTypeDropdownId    = timeConditionProviderName + RelationalTimeConditionPanelContentGenerator.CORE_MIN_RELATIVE_N_PERIODS_PERIOD_TYPE_SELECTOR_ID;
        explicitValueControlsContainerId = timeConditionProviderName + RelationalTimeConditionPanelContentGenerator.CORE_MIN_EXPLICIT_VALUE_OPTIONS_CONTAINER_ID;
    
//++++TODO        boundaryPointControlSetKey = "g_filterRankDialog.FIELDSETKEY_MIN_DATE_CONTROLS";
    }
    else
    {
        isRelativeTimeFilteringAllowed = timeConditionForm.getEndDate().isRelativeTimeFilteringAllowed();
        
        endPointLabelKey = "filter.dateLikeItem.between.max.value.editor.label.txt";
        
        dateValueTypeProperty             = RelationalTimeConditionPanelContentGenerator.MAX_VALUE_OPTION_PROPERTY;
        relativeDateAliasSelectorProperty = RelationalTimeConditionPanelContentGenerator.MAX_RELATIVE_DATE_ALIAS_PROPERTY;
        relativeNPeriodMultiplierProperty = RelationalTimeConditionPanelContentGenerator.MAX_RELATIVE_N_PERIODS_MULTIPLIER_PROPERTY ;
        relativeNPeriodTypeProperty       = RelationalTimeConditionPanelContentGenerator.MAX_RELATIVE_N_PERIOD_TYPE_PROPERTY ;
        explicitValueEditorName           = RelationalTimeConditionPanelContentGenerator.MAX_EXPLICIT_DATE_PROPERTY;
    
        endPointContainerId              = timeConditionProviderName + RelationalTimeConditionPanelContentGenerator.CORE_MAX_VALUE_OPTIONS_CONTAINER_ID;
        dateValueTypeRadioRelativeId     = timeConditionProviderName + RelationalTimeConditionPanelContentGenerator.CORE_MAX_VALUE_OPTION_RELATIVE_ID ;
        dateValueTypeRadioExplicitId     = timeConditionProviderName + RelationalTimeConditionPanelContentGenerator.CORE_MAX_VALUE_OPTION_EXPLICIT_ID ;
        relativeDateAliasSelectorId      = timeConditionProviderName + RelationalTimeConditionPanelContentGenerator.CORE_MAX_RELATIVE_DATE_ALIAS_SELECTOR_ID ;
        relativeNPeriodsContainerId      = timeConditionProviderName + RelationalTimeConditionPanelContentGenerator.CORE_MAX_RELATIVE_N_PERIODS_CONTAINER_ID;
        relativeNPeriodMultiplierFieldId = timeConditionProviderName + RelationalTimeConditionPanelContentGenerator.CORE_MAX_RELATIVE_N_PERIODS_MULTIPLIER_ID;
        relativeNPeriodTypeDropdownId    = timeConditionProviderName + RelationalTimeConditionPanelContentGenerator.CORE_MAX_RELATIVE_N_PERIODS_PERIOD_TYPE_SELECTOR_ID;
        explicitValueControlsContainerId = timeConditionProviderName + RelationalTimeConditionPanelContentGenerator.CORE_MAX_EXPLICIT_VALUE_OPTIONS_CONTAINER_ID;

    }
    String onDateValueCategoryChangeAsString 
        = panelId + ".onBetweenComparisonDateValueCategoryChange(" + isMinEndPoint + ");";
    String onRelativeValueTypeChangeAsString
        = panelId + ".onBetweenComparisonRelativeDateValueTypeChange(" + isMinEndPoint + ");";
    String onRelativeNPeriodTypeChangeAsString
        = panelId + ".onBetweenComparisonRelativeNPeriodTypeChange(" + isMinEndPoint + ");";
        
%>
<table id="<%=endPointContainerId%>" style="width:100%;" cellpadding="0" cellspacing="0" border="0" summary="" >
    <tr>
        <td class="timeCondition_ctrlLabelContainer"><span class="header"><bean:message key="<%=endPointLabelKey%>"/></span></td>
    </tr>
    <tr>
        <td>
            <table style="width: 100%;" cellpadding="0" cellspacing="0" border="0" summary="" >
                <tr style='display:<%= (isRelativeTimeFilteringAllowed) ? "block" : "none" %>'>
                    <td colspan="2" style="white-space:nowrap;text-align-left;">
                        <html:radio property="<%=dateValueTypeProperty%>" 
                                    styleId="<%=dateValueTypeRadioRelativeId%>" 
                                    styleClass="radiobutton" style="vertical-align:top;"
                                    value="<%=DateValueForm.VALUE_TYPE_CATEGORY_RELATIVE%>"
			                        disabled="<%=!isRelativeTimeFilteringAllowed%>"                                    
                                    onclick="<%=onDateValueCategoryChangeAsString%>"/>
                        <label for="<%=dateValueTypeRadioRelativeId%>"  class="label" style="vertical-align:top;">
                        	<bean:message key="rankAndFilter.filter.date.relative.date.radio.label.txt"/></label>
                        <html:select property="<%=relativeDateAliasSelectorProperty%>" 
                              styleId="<%=relativeDateAliasSelectorId%>"
                              styleClass="dropdown" style="vertical-align:top;"
                              
                              onchange="<%=onRelativeValueTypeChangeAsString%>">
                        <%
                            int dateAliasCount = timeConditionForm.getRelativeDateValueAliasCount();
                            for (int dateAliasIndex=0; dateAliasIndex<dateAliasCount; dateAliasIndex++)
			                {
			                    LabelValueBean dateAlias = timeConditionForm
			                        .getRelativeDateValueAlias(dateAliasIndex);
			            %>
			                    <html:option value="<%=dateAlias.getValue()%>">
			                        <%=CommonUtils.htmlEncodeForDisplay(dateAlias.getLabel())%>
			                    </html:option>
			            <%
			                }
			            %>
                        </html:select>
                    </td>
                </tr>
                <tr id="<%=relativeNPeriodsContainerId%>">
                    <td colspan="2" style="white-space:nowrap;" class="timeCondition_relativeDateValueCtrlContainer">
                        <html:text property="<%=relativeNPeriodMultiplierProperty%>"
                              size="5" style="margin-left:10px;margin-right:5px;"
                              styleId="<%=relativeNPeriodMultiplierFieldId%>"
                              styleClass="timeCondition_relativeNPeriodsMultiplier" onkeypress="handleEnter(this, event);"/>
                        <html:select property="<%=relativeNPeriodTypeProperty%>"
                              styleId="<%=relativeNPeriodTypeDropdownId%>"
                              styleClass="timeCondition_relativeNPeriodTypeDropdown"
                              onchange="<%=onRelativeNPeriodTypeChangeAsString%>">                              
                        <%
                            PeriodType [] periodTypes;
                            if (timeConditionForm.isTimeDataItem()) {
                                periodTypes = PeriodType.getTimeTypes();
                            } else if (timeConditionForm.isTimestampDataItem()) { 
                                periodTypes = PeriodType.getTimestampTypes();
                            } else { //assume date
                                periodTypes = PeriodType.getDateTypes();
                            }
                            int periodTypeCount = periodTypes.length;
                            for (int periodTypeIndex=0; periodTypeIndex<periodTypeCount; periodTypeIndex++)
			                {
			                    String periodTypeValue = periodTypes[periodTypeIndex].getValue();
			                    String periodTypeLabel = periodTypes[periodTypeIndex].getLabel(timeConditionForm.getLocaleProvider().getLocale());
			            %>
			                    <html:option value="<%=periodTypeValue%>">
			                        <%=CommonUtils.htmlEncodeForDisplay(periodTypeLabel)%>
			                    </html:option>
			            <%
			                } 
                        %>                  
                        </html:select>
                    </td>
                </tr>
                <tr style='display:<%= (isRelativeTimeFilteringAllowed) ? "block" : "none" %>'>
                    <td colspan="2" style="white-space:nowrap;">
                     	  <html:radio property="<%=dateValueTypeProperty%>" 
                                 styleId="<%=dateValueTypeRadioExplicitId%>" 
                                 styleClass="radiobutton" style="vertical-align:top;"
                                 value="<%=DateValueForm.VALUE_TYPE_CATEGORY_EXPLICIT%>"
                                 onclick="<%=onDateValueCategoryChangeAsString%>"/>
                     	  <label for="<%=dateValueTypeRadioExplicitId%>"  class="label" style="vertical-align:top;"><bean:message key="rankAndFilter.filter.date.fixed.date.radio.label.txt"/></label>
                    </td>
                </tr>
                <tr id="<%=explicitValueControlsContainerId%>">
	            <%
	                //labels for date fields; we obtain labels from the value editor
	                DateValueForm dateValueForm = isMinEndPoint
	                    ? timeConditionForm.getStartDate()
	                    : timeConditionForm.getEndDate();
	                DateTimeFieldForm dtBean = dateValueForm.getExplicitDate();
	                DateTimeFieldSelector dateComparisonValueEditor = EditFilterFormUiAdapter
	                    .newDateComparisonValueEditor(dtBean, 
	                        explicitValueEditorName,
	                        pageContext);	                
	            %>
			        <td colspan="2">
			            <table style="width: 100%;" cellpadding="0" cellspacing="0" border="0" summary="" >
			               <tr>
		                    <td class="timeCondition_ctrlLabelContainer" style="padding-right:10px;">
		                    <%
		                    String labelsTemplate = DateTimeFieldSelector.getDefaultLabelsTemplate(dateComparisonValueEditor.getEditorConfiguration());
		                    dateComparisonValueEditor.writeComponentLabels(out, labelsTemplate);
		                    %>
		                    </td>
		                    <td class="timeCondition_ctrlContainer">
		                    <% dateComparisonValueEditor.write(out); %>
		                    </td><!-- _end date time field editor -->
		                   </tr>
		                </table>
		           </td>
                </tr>
	            <%
	                dateComparisonValueEditor.cleanUpResources();
	            %>
            </table>
        </td>
    </tr>
</table><!-- <%=endPointContainerId%> -->
<%
    String endPointCompletionFunctionName;
    String endPointValueOptionFieldSetAccessor;
    
    if (isMinEndPoint)
    {
        endPointCompletionFunctionName = panelId + ".completeBetweenComparisonFieldSet_minInfo";
        endPointValueOptionFieldSetAccessor = "this._betweenComparisonFieldSet._minDateValueOptionsFieldSet";
    }
    else
    {
        endPointCompletionFunctionName = panelId + ".completeBetweenComparisonFieldSet_maxInfo";
        endPointValueOptionFieldSetAccessor = "this._betweenComparisonFieldSet._maxDateValueOptionsFieldSet";    
    }
%>
<script type="text/javascript"> /*<![CDATA[*/ 
    <%=endPointCompletionFunctionName%> = function ()
    {
        var bcDateValueOptionsFieldSet = new WRSDateValueOptionsFieldSet("<%=dateValueTypeProperty%>");
        <%=endPointValueOptionFieldSetAccessor%> = bcDateValueOptionsFieldSet;

        var bcRelativeDateValueFieldSet = new WRSRelativeDateValueFieldSet("<%=relativeDateAliasSelectorId%>");
        bcRelativeDateValueFieldSet.setId("<%=dateValueTypeRadioRelativeId%>");
        bcDateValueOptionsFieldSet._relativeDateOptionsFieldSet = bcRelativeDateValueFieldSet;

        <%-- 
        N periods field set - a dynamic field set with no explicit subclass of WRSFieldSet
        --%>
        var bcRelativeNPeriodsFieldSet = new WRSRelativeNPeriodInfoFieldSet();
        bcRelativeNPeriodsFieldSet._fieldSetContainerId = "<%=relativeNPeriodsContainerId%>";
        bcRelativeNPeriodsFieldSet._periodMultiplierFieldId = "<%=relativeNPeriodMultiplierFieldId%>";
        bcRelativeNPeriodsFieldSet._periodTypeSelectorId = "<%=relativeNPeriodTypeDropdownId%>";
        bcRelativeDateValueFieldSet.setEntry("<%=RelativeDateValueAlias.N_PERIODS_AGO.getValue()%>", bcRelativeNPeriodsFieldSet);
        bcRelativeDateValueFieldSet.setEntry("<%=RelativeDateValueAlias.N_PERIODS_FROM_NOW.getValue()%>", bcRelativeNPeriodsFieldSet);
                    
        var bcExplicitDateValueFieldSet = new WRSExplicitDateValueFieldSet();
        bcExplicitDateValueFieldSet.setId("<%=dateValueTypeRadioExplicitId%>");
        bcExplicitDateValueFieldSet._fieldSetContainerId = "<%=explicitValueControlsContainerId%>";
        bcExplicitDateValueFieldSet._explicitDatePropertyName = "<%=explicitValueEditorName%>";
        bcDateValueOptionsFieldSet._explicitDateOptionsFieldSet = bcExplicitDateValueFieldSet;
  
    }
    <%=endPointCompletionFunctionName%>();		        
/*]]>*/ </script>